using System;
using System.IO;
using System.Data;
using System.Data.SqlClient;
using System.Data.SqlTypes;
using Microsoft.SqlServer.Server;

public partial class StoredProcedures
{
    [Microsoft.SqlServer.Server.SqlProcedure]
    public static void FileCopy(SqlString sExistingFileNamePath, SqlString sNewFileNamePath, SqlBoolean bOverwrite)
    {
        Int16 errSeverity = 16;

        try
        {
            FileInfo fi = new FileInfo(sExistingFileNamePath.ToString());

            if (fi.Exists)
            {
                fi.CopyTo(sNewFileNamePath.ToString(), Convert.ToBoolean(bOverwrite));
            }

        }
        catch (Exception ex)
        {
            // Connect to server in event of error
            SqlConnection conn = new SqlConnection("context connection=true");
            conn.Open();

            // Generate error response to SQL Server
            string msg = string.Format("RAISERROR('{0}',{1},1)", ex.Message.Replace('\'', ' '), errSeverity);
            SqlCommand cmd = new SqlCommand(msg, conn);

            try
            {
                // Execute error on SQL Server
                SqlPipe sqlpipe = SqlContext.Pipe;
                sqlpipe.ExecuteAndSend(cmd);
                Exception newEx = new Exception(msg);
                throw newEx;
            }
            catch { } // Prevent error duplication
        }
    }
};
